<template>
  <q-input
    :model-value="formattedValue"
    filled
    icon="las la-calendar"
    :label="_label"
    :hint="hint"
    readonly
  >
    <template #append>
      <q-icon name="las la-calendar" />
    </template>
    <template #default>
      <q-popup-proxy
        @before-show="setProxyDateTime"
        transition-show="scale"
        transition-hide="scale"
      >
        <q-card>
          <q-card-section>
            <div class="row flex justify-center items-center q-gutter-lg">
              <q-date
                v-model="proxyDateTime"
                mask="YYYY-MM-DDTHH:mm:ssZ"
                :options="optionsDate"
                today-btn
              />
              <q-time
                v-model="proxyDateTime"
                mask="YYYY-MM-DDTHH:mm:ssZ"
                :options="optionsTime"
                now-btn
              />
            </div>
          </q-card-section>
          <q-card-section>
            <div class="row items-center justify-end q-gutter-sm">
              <q-btn
                :label="$gettext('Cancel')"
                flat
                v-close-popup
              />
              <q-btn
                :label="$gettext('OK')"
                color="primary"
                flat
                @click="onUpdateProxyDateTime"
                v-close-popup
              />
            </div>
          </q-card-section>
        </q-card>
      </q-popup-proxy>
    </template>
  </q-input>
</template>

<script>
import { date } from 'quasar'

import { DateMixin } from 'src/mixins/DateMixin'

export default {
  name: 'DateTimeSelectorInput',
  mixins: [DateMixin],
  props: {
    modelValue: {
      required: true,
      validator: prop => prop == null || prop instanceof Date || typeof prop === 'string'
    },
    label: {
      type: String,
      default: null
    },
    hint: {
      type: String,
      default: null
    }
  },
  emits: ['update:model-value'],
  data () {
    return {
      proxyDateTime: null
    }
  },
  computed: {
    _label () {
      if (this.label !== null) {
        return this.label
      } else {
        return this.$gettext('Date and time')
      }
    },
    formattedValue () {
      if (this.modelValue !== null) {
        return this.displayDateTime(this.modelValue)
      } else {
        return null
      }
    }
  },
  methods: {
    setProxyDateTime () {
      if (this.modelValue) {
        this.proxyDateTime = date.formatDate(this.modelValue, 'YYYY-MM-DDTHH:mm:ssZ')
      }
    },
    onUpdateProxyDateTime () {
      const proxyDateTime = this.proxyDateTime !== null ? new Date(this.proxyDateTime) : null
      this.$emit('update:model-value', proxyDateTime)
    },
    optionsDate (d) {
      return d <= date.formatDate(new Date(), 'YYYY/MM/D')
    },
    optionsTime (hr, min, sec) {
      const now = new Date()
      const selectedDate = this.proxyDateTime instanceof Date ? this.proxyDateTime : new Date(this.proxyDateTime)
      if (date.formatDate(selectedDate, 'YYYY-MM-DD') < date.formatDate(now, 'YYYY-MM-DD')) {
        return true
      } else if (hr > now.getHours()) {
        return false
      } else if (hr === now.getHours()) {
        return min <= now.getMinutes()
      }
      return true
    }
  }
}
</script>
